"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _enzyme = require("enzyme");

var _react = _interopRequireDefault(require("react"));

var _LayoutRenderer = _interopRequireDefault(require("../LayoutRenderer"));

var children = _react.default.createElement("h1", null, "Test");

var renderComponent = function renderComponent() {
  var props = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  return (0, _enzyme.shallow)(_react.default.createElement(_LayoutRenderer.default, props, children));
};

describe('<LayoutRenderer />', function () {
  it('should render an LayoutRenderer', function () {
    var renderedComponent = renderComponent({
      title: 'Title test',
      toc: _react.default.createElement("a", null, "Table of content link")
    });
    expect(renderedComponent.length).toBe(1);
  });
  it('should render an LayoutRenderer with children', function () {
    var renderedComponent = renderComponent({
      title: 'Title test',
      toc: _react.default.createElement("a", null, "Table of content link")
    });
    expect(renderedComponent.contains(children)).toEqual(true);
  });
});