"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf3 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _require = require('../../package.json'),
    homepage = _require.homepage;

var withRedux = require('./utils/withRedux');

var withIntl = require('./utils/withIntl');

var propTypes = {
  redux: _propTypes.default.object,
  'react-redux': _propTypes.default.object,
  'react-intl': _propTypes.default.object,
  reducer: _propTypes.default.func,
  messages: _propTypes.default.object,
  children: _propTypes.default.oneOfType([_propTypes.default.arrayOf(_propTypes.default.node), _propTypes.default.node]).isRequired
};
var defaultProps = {
  redux: null,
  'react-redux': null,
  'react-intl': null,
  reducer: null,
  messages: null
};

var Wrapper = function (_React$PureComponent) {
  (0, _inherits2.default)(Wrapper, _React$PureComponent);

  function Wrapper() {
    var _getPrototypeOf2;

    var _this;

    (0, _classCallCheck2.default)(this, Wrapper);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = (0, _possibleConstructorReturn2.default)(this, (_getPrototypeOf2 = (0, _getPrototypeOf3.default)(Wrapper)).call.apply(_getPrototypeOf2, [this].concat(args)));
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)(_this), "state", {
      hocList: []
    });
    return _this;
  }

  (0, _createClass2.default)(Wrapper, [{
    key: "UNSAFE_componentWillMount",
    value: function UNSAFE_componentWillMount() {
      var _this$props = this.props,
          redux = _this$props.redux,
          reactRedux = _this$props['react-redux'],
          reactIntl = _this$props['react-intl'],
          rest = (0, _objectWithoutProperties2.default)(_this$props, ["redux", "react-redux", "react-intl"]);
      var reducer = rest.reducer,
          messages = rest.messages;
      var hocList = [];

      if (reducer) {
        if (!redux || !reactRedux) {
          throw new Error("Wrapper: You need to pass the props `redux` and `react-redux` to use props `reducer`, see ".concat(homepage, "/#wrapper"));
        }

        hocList.push(withRedux({
          redux: redux,
          'react-redux': reactRedux
        }, reducer));
      }

      if (messages) {
        if (!redux || !reactRedux || !reactIntl) {
          throw new Error("Wrapper: You need to pass the props `redux`, `react-redux` and `redux-intl` to use props `reducer`, see ".concat(homepage, "/#wrapper"));
        }

        if (!reducer) {
          throw new Error("Wrapper: `react-intl` can't work without a reducer, see ".concat(homepage, "/#wrapper"));
        }

        var _reducer = reducer(),
            locale = _reducer.locale;

        if (!locale) {
          throw new Error("Wrapper: `react-intl` must have a locale set in redux store, see ".concat(homepage, "/#wrapper"));
        }

        hocList.push(withIntl({
          'react-intl': reactIntl
        }, locale, messages));
      }

      this.setState({
        hocList: hocList
      });
    }
  }, {
    key: "render",
    value: function render() {
      var children = this.props.children;
      var hocList = this.state.hocList;

      if (hocList.length === 0) {
        return _react.default.createElement("div", null, children);
      }

      var Component = null;
      var cursor;

      while (cursor = hocList.shift()) {
        Component = cursor(Component || 'div');
      }

      return _react.default.createElement(Component, null, children);
    }
  }]);
  return Wrapper;
}(_react.default.PureComponent);

exports.default = Wrapper;
(0, _defineProperty2.default)(Wrapper, "propTypes", propTypes);
(0, _defineProperty2.default)(Wrapper, "defaultProps", defaultProps);
module.exports = exports.default;