"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _react = _interopRequireDefault(require("react"));

var _enzyme = require("enzyme");

var _withRedux = _interopRequireDefault(require("../withRedux"));

describe('withRedux', function () {
  var mockRedux = {
    applyMiddleware: function applyMiddleware() {
      return jest.fn();
    },
    createStore: jest.fn(),
    compose: jest.fn()
  };
  var mockReactRedux = {
    Provider: function Provider(_ref) {
      var props = _ref.props,
          store = _ref.store;
      return _react.default.createElement("div", props);
    }
  };

  var reducer = function reducer(action, state) {
    return state;
  };

  it('should render withRedux', function () {
    var Redux = (0, _withRedux.default)({
      redux: mockRedux,
      'react-redux': mockReactRedux
    }, reducer)('div');
    Redux.prototype.componentWillMount = jest.fn();
    var renderedComponent = (0, _enzyme.shallow)(_react.default.createElement(Redux, null, "hello"));
    expect(renderedComponent.find('Provider').length).toBe(1);
    expect(Redux.prototype.componentWillMount).toHaveBeenCalled();
  });
});